﻿@using Jb.Framework.Common.Forms
@using Jb.Framework.Common.Forms.Validation
@using Jumbula.Common.Helper
@model  JbTextBox

@{

    var textBoxHtmlAttr = new Dictionary<string, object>();
    var cssClasses = new List<string>();

    cssClasses.Add(Model.Size.ToDescription());

    var width = "element_width-third";
    switch (Model.Width)
    {
        case ElementWidth.Half:
            {
                width = "element_width-half";
            }
            break;
        case ElementWidth.Full:
            {
                width = "element_width-full";
            }
            break;
    }

    if (Model.Name == ElementsName.DoB.ToString() || Model.Name == ElementsName.DateOfBirth.ToString())
    {
        cssClasses.Add("dob");
    }

    if (cssClasses.Any())
    {
        textBoxHtmlAttr.Add("class", string.Join(" ", cssClasses) + " form-control");
    }

    textBoxHtmlAttr.Add("placeholder", Model.PlaceHolder);
    textBoxHtmlAttr.Add("data-clientid", Model.Name);
    if (Model.CurrentMode != AccessMode.Design)
    {
        if (Model.IsRequired || Model.Validations.Any(x => x.Type != ElementValidationType.None))
        {
            textBoxHtmlAttr.Add("data-val", "true");
        }
        if (Model.Validations.Any(x => x.Type == ElementValidationType.Required))
        {
            textBoxHtmlAttr.Add("data-val-Required", Model.Validations.First(x => x.Type == ElementValidationType.Required).Message);
        }
        else if (Model.IsRequired)
        {
            textBoxHtmlAttr.Add("data-val-Required", Model.Title + " is required.");
        }

        if (Model.CurrentMode == AccessMode.ReadOnly)
        {
            textBoxHtmlAttr.Add("ReadOnly", true);
        }

        if(Model.IsConditional)
        {
            textBoxHtmlAttr.Add("data-conditional", true);
            textBoxHtmlAttr.Add("data-RelatedElementId", Model.RelatedElementId);
            textBoxHtmlAttr.Add("data-RelatedElementValue", Model.RelatedElementValue);
        }

        //textBoxHtmlAttr.Add("data-error", Html.ValidationMessageForText(model => model.Value));
    }

}

<div class="form-group JbFormControll JbTextBox @width" style="display: @(Model.VisibleMode != VisibilityMode.Both && Model.VisibleMode != (VisibilityMode)ViewBag.VisibleMode ? "none" : "block")">
    @for (var i = 0; i < Model.Validations.Count; i++)
    {
        //Custom model binder require full model name , i add Validations[i] at the end of string that mvc generate
        var hiddnModelBindername = "Validations[" + i + "].QVModelType";
        @Html.Hidden(hiddnModelBindername, Model.Validations[i].GetType())

        @Html.HiddenFor(x => x.Validations[i].IsChecked)
        @Html.HiddenFor(x => x.Validations[i].Type)
        @Html.HiddenFor(x => x.Validations[i].Message)
    }
    @Html.GenerateHiddenFields(Model)
    @Html.LabelFor(m => m.Value, Model.Title, new { @class = (Model.Validations.Any(t => t.Type == ElementValidationType.Required) || Model.IsRequired) ? "req" : "" })
    @if (!string.IsNullOrEmpty(Model.HelpText))
    {
        <a href="#" class="help" role="button" data-toggle="popover" data-trigger="focus" data-content="@Model.HelpText"></a>
    }

    @Html.TextBoxFor(model => model.Value, htmlAttributes: textBoxHtmlAttr)
    @Html.ValidationMessageFor(model => model.Value)
</div>